      PROGRAM BACSUBS
C     ----------------------------------------------------------------
C     Alg3'1.for   FORTRAN program for implementing Algorithm 3.1
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 3.1 (Back Substitution).
C     Section   3.3, Upper-Triangular Linear Systems, Page 145
C     ----------------------------------------------------------------
      PARAMETER(MaxR=10)
      INTEGER InRC,N
      REAL A,B,DET,X
      CHARACTER Ans*1,Ach*1,Bch*1,Xch*1
      DIMENSION A(1:MaxR,1:MaxR),B(1:MaxR),X(1:MaxR)
10    CALL INPUTS(A,B,N,InRC,DET)
      CALL BACKSUB(A,B,N,X,DET)
      CALL RESULTS(A,B,N,X,DET)
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO SOLVE ANOTHER UPPER-TRIANGULAR SYSTEM ? <Y/N> '
      READ(9,'(A)') Ans
      IF (Ans.EQ.'Y' .OR. Ans.EQ.'y') GOTO 10
      STOP
      END

      SUBROUTINE BACKSUB(A,B,N,X,DET)
      PARAMETER(MaxR=10)
      INTEGER J,K,N,R
      REAL A,B,DET,SUM,X
      DIMENSION A(1:MaxR,1:MaxR),B(1:MaxR),X(1:MaxR)
      DO K=1,N
      IF (A(K,K).EQ.0) THEN
         DET=0
         RETURN
      ENDIF
      ENDDO
      DET=A(N,N)
      X(N)=B(N)/A(N,N)
      DO R=(N-1),1,-1
        DET=DET*A(R,R)
        SUM= 0
        DO J=(R+1),N
          SUM=SUM+A(R,J)*X(J)
        ENDDO
      X(R)= (B(R)-SUM)/A(R,R)
      ENDDO
      RETURN
      END

      SUBROUTINE XACKSUB(A,B,N,X,DET)
      PARAMETER(MaxR=10)
      INTEGER J,K,N,R
      REAL A,B,DET,SUM,X
      DIMENSION A(1:MaxR,1:MaxR),B(1:MaxR),X(1:MaxR)
      DO 10 K=1,N
      IF (A(K,K).EQ.0) THEN
         DET=0
         RETURN
      ENDIF
10    CONTINUE
      DET=A(N,N)
      X(N)=B(N)/A(N,N)
      DO 30 R=(N-1),1,-1
        DET=DET*A(R,R)
        SUM= 0
        DO 20 J=(R+1),N
          SUM=SUM+A(R,J)*X(J)
20      CONTINUE
      X(R)= (B(R)-SUM)/A(R,R)
30    CONTINUE
      RETURN
      END

      SUBROUTINE INPUTS(A,B,N,InRC,DET)
      PARAMETER(MaxR=10)
      INTEGER C,I,InRC,N,R
      REAL A,B,DET
      CHARACTER Ans*1,Ach*1
      DIMENSION A(1:MaxR,1:MaxR),B(1:MaxR)
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'SOLUTION OF AN UPPER-TRIANGULAR LINEAR SYSTEM:'
      WRITE(9,*)' '
      WRITE(9,*)'      A*X = B'
      WRITE(9,*)' '
      WRITE(9,*)'A  IS AN  N BY N  UPPER-TRIANGULAR MATRIX.'
      WRITE(9,*)' '
      WRITE(9,*)'B  IS AN  N  DIMENSIONAL VECTOR OF CONSTANTS.'
      WRITE(9,*)' '
      WRITE(9,*)'X  IS THE N DIMENSIONAL SOLUTION VECTOR.'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE NUMBER OF EQUATIONS N = '
      READ(9,*) N
      InRC=0
      WRITE(9,*)'WANT TO INPUT COLUMNS ? <Y/N> '
      READ(9,'(A)') Ans
      IF (Ans.EQ.'Y' .OR. Ans.EQ.'y') THEN
        InRC=1
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE UPPER-TRIANGULAR MATRIX A(I,J):'
      CALL MATIN('A',A,N,InRC)
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE COLUMN VECTOR B(J):'
      CALL VECIN('B',B,N)
      RETURN
      END

      SUBROUTINE MATIN(Ach,A,N,InRC)
      PARAMETER(MaxR=10)
      INTEGER Col,InRC,N,Row
      REAL A
      CHARACTER Ach*1
      DIMENSION A(1:MaxR,1:MaXR)
      DO 20 Row=1,N
      DO 10 Col=1,N
        A(Row,Col)=0
10    CONTINUE
20    CONTINUE
      WRITE(9,*)'GIVE THE ELEMENTS OF THE MATRIX ',Ach
      WRITE(9,*)' '
      IF (InRC.EQ.0) THEN
        DO 40 Row=1,N
          WRITE(9,*)'GIVE THE ELEMENTS OF ROW ',Row
          WRITE(9,*)' '
        DO 30 Col=Row,N
          WRITE(9,*) Ach,'(',Row,',',Col,') = '
          READ(9,*) A(Row,Col)
30      CONTINUE
40      CONTINUE
      ELSE
        DO 60 Col=1,N
          WRITE(9,*)'GIVE THE ELEMENTS OF COLUMN ',Col
          WRITE(9,*)' '
        DO 50 Row=1,Col
          WRITE(9,*) Ach,'(',Row,',',Col,') = '
          READ(9,*) A(Row,Col)
50      CONTINUE
60      CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE VECIN(Bch,B,N)
      PARAMETER(MaxR=10)
      INTEGER N,Row
      REAL B
      CHARACTER Bch*1
      DIMENSION B(1:MaxR)
      WRITE(9,*)'GIVE THE ELEMENTS OF THE COLUMN VECTOR ',Bch
      WRITE(9,*)' '
      DO 10 Row=1,N
        WRITE(9,*) Bch,'(',Row,') = '
        READ(9,*) B(Row)
10    CONTINUE
      RETURN
      END

      SUBROUTINE MATPRINT(A,N)
      PARAMETER(MaxR=10)
      INTEGER Col,N,Row
      REAL A
      DIMENSION A(1:MaxR,1:MaxR)
      DO 10 Row=1,N
        WRITE(9,999) ( A(Row,Col), Col=1,N )
10    CONTINUE
999   FORMAT(1X,5F15.7,4X)
      RETURN
      END

      SUBROUTINE VECPRINT(Bch,B,Xch,X,N)
      PARAMETER(MaxR=10)
      INTEGER N,Row
      REAL B,X
      CHARACTER Bch*1,Xch*1
      DIMENSION B(1:MaxR),X(1:MaxR)
      WRITE(9,*) Bch,' COEFFICIENT VECTOR                ',Xch,
     +' SOLUTION VECTOR'
      WRITE(9,*)
      DO 10 Row=1,N
        WRITE(9,*) Bch,'(',Row,') =',B(Row),'                     ',
     +Xch,'(',Row,') =',X(Row)
10    CONTINUE
      RETURN
      END

      SUBROUTINE RESULTS(A,B,N,X,DET)
      PARAMETER(MaxR=10)
      INTEGER Col,I,N,Row
      REAL A,B,DET,X
      CHARACTER Bch*1,Xch*1
      DIMENSION A(1:MaxR,1:MaxR),B(1:MaxR),X(1:MaxR)
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'THE UPPER-TRIANGULAR MATRIX A(I,J) IS:'
      WRITE(9,*)' '
      CALL MATPRINT(A,N)
      IF (DET.EQ.0) THEN
        WRITE(9,*)'THE MATRIX IS SINGULAR.'
        WRITE(9,*)
        WRITE(9,*)'THE BACK-SUBSTITUTION ALGORITHM DOES NOT APPLY.'
      ELSE
        WRITE(9,*)
        CALL VECPRINT('B',B,'X',X,N)
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'THE DETERMINANT`S VALUE IS  DET A = ',DET
      RETURN
      END
