      PROGRAM GAUSJORD
C     ----------------------------------------------------------------
C     Alg3'2.for   FORTRAN program for implementing Algorithm 3.2
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 3.2 (Upper-Triangularization Followed by Back Sub.).
C     Section   3.4, Gaussian Elimination and Pivoting, Page 156
C     ----------------------------------------------------------------
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER InRC,N
      REAL A,A1,DET,X
      CHARACTER Ans*1,Ach*1,Bch*1,Xch*1
      DIMENSION A(1:MaxR,1:MaxC),A1(1:MaxR,1:MaxC),X(1:MaxR)
10    CALL INPUTS(A,A1,N,InRC)
      CALL GAUSSJO(A,X,N,DET)
      CALL RESULTS(A1,X,N,DET)
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO SOLVE ANOTHER LINEAR SYSTEM ? <Y/N> '
      READ(9,'(A)') Ans
      IF (Ans.EQ.'Y' .OR. Ans.EQ.'y') GOTO 10
      STOP
      END

      SUBROUTINE GAUSSJO(A,X,N,DET)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER C,J,K,N,P,R,Row,T
      REAL A,DET,M,SUM,X
      DIMENSION A(1:MaxR,1:MaxC),Row(1:MaxR),X(1:MaxR)
      DO J=1,N
        Row(J)=J
      ENDDO
      DO P=1,(N-1)
        DO K=(P+1),N
          IF (ABS(A(Row(K),P)).GT.ABS(A(Row(P),P))) THEN
            T = Row(P)
            Row(P)=Row(K)
            Row(K)=T
          ENDIF
        ENDDO
        IF (A(Row(P),P).EQ.0) THEN
            DET=0
            RETURN
        ENDIF
        DO K=(P+1),N
          M = A(Row(K),P)/A(Row(P),P)
          DO C=(P+1),(N+1)
            A(Row(K),C)=A(Row(K),C)-M*A(Row(P),C)
          ENDDO
        ENDDO
      ENDDO
      DET=A(Row(N),N)
      IF (DET.NE.0) THEN
        X(N)=A(Row(N),(N+1))/A(Row(N),N)
        DO K=(N-1),1,-1
          DET=DET*A(Row(K),K)
          SUM=0
          DO C=(K+1),N
            SUM=SUM+A(Row(K),C)*X(C)
          ENDDO
          X(K)=(A(Row(K),(N+1))-SUM)/A(Row(K),K)
        ENDDO
      ENDIF
      RETURN
      END

      SUBROUTINE XAUSSJO(A,X,N,DET)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER C,J,K,N,P,R,Row,T
      REAL A,DET,M,SUM,X
      DIMENSION A(1:MaxR,1:MaxC),Row(1:MaxR),X(1:MaxR)
      DO 10 J=1,N
        Row(J)=J
10    CONTINUE
      DO 50 P=1,(N-1)
      DO 20 K=(P+1),N
        IF (ABS(A(Row(K),P)).GT.ABS(A(Row(P),P))) THEN
          T = Row(P)
          Row(P)=Row(K)
          Row(K)=T
        ENDIF
20    CONTINUE
        IF (A(Row(P),P).EQ.0) THEN
            DET=0
            RETURN
        ENDIF
        DO 40 K=(P+1),N
          M = A(Row(K),P)/A(Row(P),P)
          DO 30 C=(P+1),(N+1)
          A(Row(K),C)=A(Row(K),C)-M*A(Row(P),C)
30        CONTINUE
40      CONTINUE
50    CONTINUE
      DET=A(Row(N),N)
      IF (DET.NE.0) THEN
        X(N)=A(Row(N),(N+1))/A(Row(N),N)
        DO 70 K=(N-1),1,-1
          DET=DET*A(Row(K),K)
          SUM=0
          DO 60 C=(K+1),N
            SUM=SUM+A(Row(K),C)*X(C)
60        CONTINUE
          X(K)=(A(Row(K),(N+1))-SUM)/A(Row(K),K)
70      CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE INPUTS(A,A1,N,InRC)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER Col,I,InRC,N,Row
      REAL A
      CHARACTER Ans*1,Ach*1
      DIMENSION A(1:MaxR,1:MaxC),A1(1:MaxR,1:MaxC)
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'SOLUTION OF A LINEAR SYSTEM:'
      WRITE(9,*)' '
      WRITE(9,*)'      A*X = B'
      WRITE(9,*)' '
      WRITE(9,*)'GAUSSIAN ELIMINATION IS USED TO UPPER-TRIANGULARIZE,'
      WRITE(9,*)' '
      WRITE(9,*)'AND THEN BACK-SUBSTITUTION IS USED TO SOLVE FOR  X.'
      WRITE(9,*)' '
      WRITE(9,*)'A  IS AN  N BY N  NONSINGULAR MATRIX.'
      WRITE(9,*)' '
      WRITE(9,*)'B  IS AN  N  DIMENSIONAL VECTOR OF CONSTANTS.'
      WRITE(9,*)' '
      WRITE(9,*)'X  IS THE N DIMENSIONAL SOLUTION VECTOR.'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE NUMBER OF EQUATIONS N = '
      READ(9,*) N
      InRC=0
      WRITE(9,*)'WANT TO INPUT COLUMNS ? <Y/N> '
      READ(9,'(A)') Ans
      IF (Ans.EQ.'Y' .OR. Ans.EQ.'y') THEN
        InRC=1
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE COEFFICIENT MATRIX  A:'
      CALL MATIN('A',A,N,InRC)
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE COLUMN VECTOR  B:'
      CALL VECIN('B',A,N,InRC)
      DO 30 Row=1,N
      DO 20 Col=1,N+1
        A1(Row,Col)=A(Row,Col)
20    CONTINUE
30    CONTINUE
      RETURN
      END

      SUBROUTINE MATIN(Ach,A,N,InRC)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER Col,InRC,N,Row
      REAL A
      CHARACTER Ach*1
      DIMENSION A(1:MaxR,1:MaxC)
      DO 20 Row=1,N
        DO 10 Col=1,(N+1)
          A(Row,Col)=0
10      CONTINUE
20    CONTINUE
      WRITE(9,*)'GIVE THE ELEMENTS OF THE MATRIX ',Ach
      WRITE(9,*)' '
      IF (InRC.EQ.0) THEN
        DO 40 Row=1,N
          WRITE(9,*)'GIVE THE ELEMENTS OF ROW ',Row
          WRITE(9,*)' '
          DO 30 Col=1,N
            WRITE(9,*) Ach,'(',Row,',',Col,') = '
            READ(9,*) A(Row,Col)
30        CONTINUE
40      CONTINUE
      ELSE
        DO 60 Col=1,N
          WRITE(9,*)'GIVE THE ELEMENTS OF COLUMN ',Col
          WRITE(9,*)' '
          DO 50 Row=1,N
            WRITE(9,*) Ach,'(',Row,',',Col,') = '
            READ(9,*) A(Row,Col)
50        CONTINUE
60      CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE VECIN(Ach,A,N,InRC)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER Col,InRC,N,Row
      REAL A
      CHARACTER Ach*1
      DIMENSION A(1:MaxR,1:MaxC)
      WRITE(9,*)'GIVE THE ELEMENTS OF THE COLUMN VECTOR ',Ach
      WRITE(9,*)' '
      Col=N+1
      DO 10 Row=1,N
        WRITE(9,*) Ach,'(',Row,') = '
        READ(9,*) A(Row,Col)
10    CONTINUE
      RETURN
      END

      SUBROUTINE MATPRINT(A,N)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER Col,N,Row
      REAL A
      DIMENSION A(1:MaxR,1:MaxC)
      DO 10 Row=1,N
        WRITE(9,999) ( A(Row,Col), Col=1,N )
10    CONTINUE
999   FORMAT(1X,5F15.7,4X)
      RETURN
      END

      SUBROUTINE VECPRINT(Bch,Xch,A,X,N)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER Col,N,Row
      REAL A,X
      CHARACTER Bch*1,Xch*1
      DIMENSION A(1:MaxR,MaxC),X(1:MaxR)
      Col=N+1
      WRITE(9,*) Bch,' COEFFICIENT VECTOR                ',Xch,
     +' SOLUTION VECTOR'
      WRITE(9,*)
      DO 10 Row=1,N
        WRITE(9,*) Bch,'(',Row,') =',A(Row,Col),'                     ',
     +Xch,'(',Row,') =',X(Row)
10    CONTINUE
      RETURN
      END

      SUBROUTINE RESULTS(A,X,N,DET)
      PARAMETER(MaxR=10,MaxC=11)
      INTEGER I,N
      REAL A,DET,X
      CHARACTER Bch*1,Xch*1
      DIMENSION A(1:MaxR,1:MaxC),X(1:MaxR)
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'COMPUTATION OF THE SOLUTION FOR THE LINEAR SYSTEM A*X =
     + B.'
      WRITE(9,*)' '
      WRITE(9,*)'GAUSSIAN ELIMINATION WAS USED TO UPPER-TRIANGULARIZE,'
      WRITE(9,*)' '
      WRITE(9,*)'AND THEN BACK-SUBSTITUTION IS USED TO SOLVE FOR  X.'
      WRITE(9,*)' '
      WRITE(9,*)'THE COEFFICIENT MATRIX  A  IS:'
      WRITE(9,*)' '
      CALL MATPRINT(A,N)
      IF (DET.EQ.0) THEN
        WRITE(9,*)
        WRITE(9,*)'THE MATRIX IS SINGULAR.'
        WRITE(9,*)
        WRITE(9,*)'A ZERO PIVOT ELEMENT WAS ENCOUNTERED.'
        WRITE(9,*)' '
        WRITE(9,*)'THE METHOD DOES NOT APPLY.'
      ELSE
        WRITE(9,*)
        CALL VECPRINT('B','X',A,X,N)
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'THE DETERMINANT`S VALUE IS  DET A = ',DET
      RETURN
      END
