      PROGRAM LAGPOL
C     ----------------------------------------------------------------
C     Alg4'3.for   FORTRAN program for implementing Algorithm 4.3
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 4.3 (Lagrange Approximation).
C     Section   4.3, Lagrange Approximation, Page 224
C     ----------------------------------------------------------------
      PARAMETER(MaxN=15)
      INTEGER N
      REAL P,T,X,Y
      CHARACTER ANS*1
      DIMENSION X(0:MaxN),Y(0:MaxN)
      EXTERNAL P
10    CALL GETDATAS(X,Y,N)
20    CALL EVALUATE(X,Y,N)
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO EVALUATE P(T) AGAIN ? '
      READ(9,'(A)') ANS
      IF (ANS.EQ.'Y' .OR. ANS.EQ.'y') GOTO 20
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO TRY A DIFFERENT SET OF POINTS ? '
      READ(9,'(A)') ANS
      IF (ANS.EQ.'Y' .OR. ANS.EQ.'y') GOTO 10
      RETURN
      END

      REAL FUNCTION P(X,Y,N,T)
      PARAMETER(MaxN=15)
      INTEGER J,K,N
      REAL Sum,T,Term,X,Y
      DIMENSION X(0:MaxN),Y(0:MaxN)
        Sum=0
        DO K=0,N
          Term=Y(K)
          DO J=0,N
            IF (J.NE.K) Term=Term*(T-X(J))/(X(K)-X(J))
          ENDDO
          Sum=Sum+Term
        ENDDO
        P=Sum
        RETURN
      END

      REAL FUNCTION XP(X,Y,N,T)
      PARAMETER(MaxN=15)
      INTEGER J,K,N
      REAL Sum,T,Term,X,Y
      DIMENSION X(0:MaxN),Y(0:MaxN)
      Sum=0
      DO 20 K=0,N
        Term=Y(K)
        DO 10 J=0,N
          IF (J.NE.K) Term=Term*(T-X(J))/(X(K)-X(J))
10      CONTINUE
        Sum=Sum+Term
20    CONTINUE
      P=Sum
      RETURN
      END

      SUBROUTINE GETDATAS(X,Y,N)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL X,Y
      DIMENSION X(0:MaxN),Y(0:MaxN)
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)' '
      WRITE(9,*)'THE LAGRANGE POLYNOMIAL IS USED TO INTERPOLATE'
      WRITE(9,*)' '
      WRITE(9,*)'BASED ON THE N+1 POINTS (X ,Y ),...,(X ,Y )'
      WRITE(9,*)'                          0  0        N  N'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE NUMBER  N = '
      READ(9,*) N
      WRITE(9,*)' '
      WRITE(9,*)'NOW ENTER THE   N =',N+1,'  POINTS'
      WRITE(9,*)' '
      WRITE(9,*)'(X ,Y ),(X ,Y ),...,(X ,Y )'
      WRITE(9,*)'  0  0    1  1        N  N'
      WRITE(9,*)' '
      DO 20 K=0,N
        WRITE(9,*)'X(',K,') = '
        READ(9,*) X(K)
        WRITE(9,*)'Y(',K,') = '
        READ(9,*) Y(K)
        WRITE(9,*)' '
20    CONTINUE
      RETURN
      END

      SUBROUTINE EVALUATE(X,Y,N)
      PARAMETER(MaxN=15)
      INTEGER K,N
      REAL T,X,Y
      DIMENSION X(0:MaxN),Y(0:MaxN)
      EXTERNAL P
      DO 10 I=1,18
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)' '
      WRITE(9,*)'THE LAGRANGE POLYNOMIAL INTERPOLATION BASED ON THE N+1
     + POINTS'
      WRITE(9,*)' '
      DO 20 K=0,N
        WRITE(9,*)'X(',K,') =',X(K),'      Y(',K,') =',Y(K)
20    CONTINUE
      WRITE(9,*)' '
      WRITE(9,*)'NOW EVALUATE  P(T)'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER A VALUE   T = '
      READ(9,*) T
      WRITE(9,*)' '
      WRITE(9,*)'THE VALUE OF THE LAGRANGE POLYNOMIAL IS '
      WRITE(9,*)' '
      WRITE(9,*)'P(',T,'  ) = ',P(X,Y,N,T)
      WRITE(9,*)' '
      RETURN
      END
