      PROGRAM TRIGPOLY
C     ----------------------------------------------------------------
C     Alg5'5.for   FORTRAN program for implementing Algorithm 5.5
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 5.5 (Trigonometric Polynomials).
C     Section   5.4, Fourier Series and Trig. Polynomials, Page 311
C     ----------------------------------------------------------------
      PARAMETER(MaxN=361,MaxM=181,Pi=3.14159265358979323846,FunMax=7)
      INTEGER Ftype,FunType,Itype,M,M0,N,N0
      REAL A,B,L,X,Y
      DIMENSION A(0:361),B(0:361),X(0:361),Y(0:361)
      EXTERNAL F,FX,TP
      CALL GETDATA(F,X,Y,M,M0,N,N0,A0,B0,L,Ftype,Itype,FunType,FunMax)
      CALL COEFFIC(X,Y,A,B,M,M0,N,N0,L)
      CALL RESULTS(TP,A,B,X,Y,XK,M,M0,N,N0,L,Itype,Ftype,FunType)
      STOP
      END

      FUNCTION FX(X,FunType)
      PARAMETER(Pi=3.14159265358979323846)
      INTEGER FunType
      REAL X
      IF (FunType.EQ.1) THEN
          IF (X.LT.-Pi)  FX=X+2*Pi
          IF ((-Pi.LE.X).AND.(X.LT.0))  FX=0
          IF ((0.LE.X).AND.(X.LT.Pi))  FX=X
          IF (Pi.LE.X)  FX=0
      ELSEIF (FunType.EQ.2) THEN
          IF (X.LT.-Pi) FX=1
          IF ((-Pi.LE.X).AND.(X.LT.0))  FX=-1
          IF ((0.LE.X).AND.(X.LT.Pi))  FX=1
          IF (Pi.LE.X)  FX=-1
      ELSEIF (FunType.EQ.3) THEN
          IF (X.LT.-Pi)  FX=-3*Pi/2 - X
          IF ((-Pi.LE.X).AND.(X.LT.0))  FX=Pi/2 + X
          IF ((0.LE.X).AND.(X.LT.Pi))  FX=Pi/2 - X
          IF (Pi.LE.X)  FX=-3*Pi/2 + X
      ELSEIF (FunType.EQ.4) THEN
          IF (X.LT.-Pi)  FX=-1
          IF ((-Pi.LE.X).AND.(X.LT.-Pi/2))  FX=-1
          IF ((-Pi/2.LE.X).AND.(X.LT.Pi/2))  FX=1
          IF ((Pi/2.LE.X).AND.(X.LT.Pi))  FX=-1
          IF (Pi.LE.X)  FX=-1
      ELSEIF (FunType.EQ.5) THEN
          IF (X.LT.-Pi)  FX=Pi + X
          IF ((-Pi.LE.X).AND.(X.LT.-Pi/2))  FX=-Pi - X
          IF ((-Pi/2.LE.X).AND.(X.LT.Pi/2))  FX=X
          IF ((Pi/2.LE.X).AND.(X.LT.Pi))  FX=Pi - X
          IF (Pi.LE.X)  FX=-Pi + X
      ELSEIF (FunType.EQ.6) THEN
          IF (X.LT.-Pi)  FX=(X+2*Pi)*(X+2*Pi)/4
          IF ((-Pi.LE.X).AND.(X.LT.Pi))  FX=X*X/4
          IF (Pi.LE.X)  FX=(X-2*Pi)*(X-2*Pi)/4
      ELSEIF (FunType.EQ.7) THEN
          IF (X.LT.-Pi)  FX=X/2+Pi
          IF ((-Pi.LE.X).AND.(X.LT.Pi))  FX=X/2
          IF (Pi.LE.X)  FX=X/2-Pi
      ENDIF
      RETURN
      END

      SUBROUTINE PRINTFUN(FunType)
      INTEGER FunType
      IF (FunType.EQ.1) THEN
          WRITE(9,*)'<1>  F(X) = X + 2*Pi  for          X < -Pi '
          WRITE(9,*)'     F(X) = 0         for -Pi  <=  X  <  0 '
          WRITE(9,*)'     F(X) = X         for   0  <=  X  <  Pi'
          WRITE(9,*)'     F(X) = 0         for  Pi  <=  X '
      ELSEIF (FunType.EQ.2) THEN
          WRITE(9,*)'<2>  F(X) =  1  for          X  <= -Pi '
          WRITE(9,*)'     F(X) = -1  for -Pi  <=  X < 0 '
          WRITE(9,*)'     F(X) =  1  for  0   <=  X  <   Pi '
          WRITE(9,*)'     F(X) = -1  for  Pi  <=  X '
      ELSEIF (FunType.EQ.3) THEN
          WRITE(9,*)'<3>  F(X) = -3*Pi/2 - X  for          X  < -Pi'
          WRITE(9,*)'     F(X) = Pi/2 + X     for -Pi  <=  X  <  0'
          WRITE(9,*)'     F(X) = Pi/2 - X     for   0  <=  X  <  Pi'
          WRITE(9,*)'     F(X) = -3Pi/2 + X   for  Pi  <=  X '
      ELSEIF (FunType.EQ.4) THEN
          WRITE(9,*)'<4>  F(X) = -1  for             X  < -Pi '
          WRITE(9,*)'     F(X) = -1  for    -Pi  <=  X  < -Pi/2 '
          WRITE(9,*)'     F(X) =  1  for  -Pi/2  <=  X  <  Pi/2 '
          WRITE(9,*)'     F(X) = -1  for   Pi/2  <=  X  <  Pi '
          WRITE(9,*)'     F(X) = -1  for     Pi  <=  X '
      ELSEIF (FunType.EQ.5) THEN
          WRITE(9,*)'<5>  F(X) =  Pi + X  for             X  < -Pi '
          WRITE(9,*)'     F(X) = -Pi - X  for    -Pi  <=  X  < -Pi/2'
          WRITE(9,*)'     F(X) =  X       for  -Pi/2  <=  X  <  Pi/2'
          WRITE(9,*)'     F(X) =  Pi - X  for   Pi/2  <=  X  <  Pi '
          WRITE(9,*)'     F(X) = -Pi + X  for     Pi  <=  X '
      ELSEIF (FunType.EQ.6) THEN
          WRITE(9,*)'<6>  F(X) =  (X+2Pi)^2/4  for             X  < -Pi'
          WRITE(9,*)'     F(X) =  X*X/4        for    -Pi  <=  X  <  Pi'
          WRITE(9,*)'     F(X) =  (X-2Pi)^2/4  for     Pi  <=  X '
      ELSEIF (FunType.EQ.7) THEN
          WRITE(9,*)'<7>  F(X) = X/2 + Pi  for          X  < -Pi '
          WRITE(9,*)'     F(X) = X/2       for -Pi  <=  X  <  Pi '
          WRITE(9,*)'     F(X) = X/2 - Pi  for  Pi  <=  X '
      ENDIF
      RETURN
      END

      FUNCTION F(X,FunType)
      REAL X,XL,XR
      EXTERNAL FX
          XL=X - 0.000001
          XR=X + 0.000001
          F=(FX(XL,FunType)+FX(XR,FunType))/2
      RETURN
      END

      SUBROUTINE COEFFIC(X,Y,A,B,M,M0,N,N0,L)
      PARAMETER(Pi=3.14159265358979323846)
      INTEGER J,K,M,M0,N,N0
      REAL A,B,L,T,X,Y
      DIMENSION A(0:361),B(0:361),X(0:361),Y(0:361)
      DO K=0,M0
        A(K)=0
        B(K)=0
      ENDDO
      DO K=1,N
        A(0)=A(0)+Y(K)
        DO J=1,M0
          T=J*Pi*X(K)/L
          A(J)=A(J)+Y(K)*COS(T)
          B(J)=B(J)+Y(K)*SIN(T)
        ENDDO
      ENDDO
      DO J=0,M0
        A(J)=2*A(J)/N
        B(J)=2*B(J)/N
      ENDDO
      RETURN
      END

      FUNCTION TP(A,B,M,M0,L,X)
      PARAMETER(Pi=3.14159265358979323846)
      INTEGER J,M,M0
      REAL A,B,L,P,X,Z
      DIMENSION A(0:361),B(0:361)
      P=A(0)/2
      DO J=1,M
        Z=J*Pi*X/L
        P=P+A(J)*COS(Z)+B(J)*SIN(Z)
      ENDDO
      IF (M.LT.M0) THEN
        Z=M0*Pi*X/L
        P=P+A(M0)*COS(Z)/2
      ENDIF
      TP=P
      RETURN
      END

      SUBROUTINE XOEFFIC(X,Y,A,B,M,M0,N,N0,L)
      PARAMETER(Pi=3.14159265358979323846)
      INTEGER J,K,M,M0,N,N0
      REAL A,B,L,T,X,Y
      DIMENSION A(0:361),B(0:361),X(0:361),Y(0:361)
      DO 10 K=0,M0
          A(K)=0
          B(K)=0
10    CONTINUE
      DO 30 K=1,N
          A(0)=A(0)+Y(K)
          DO 30 J=1,M0
              T=J*Pi*X(K)/L
              A(J)=A(J)+Y(K)*COS(T)
              B(J)=B(J)+Y(K)*SIN(T)
20        CONTINUE
30    CONTINUE
      DO 40 J=0,M0
          A(J)=2*A(J)/N
          B(J)=2*B(J)/N
40    CONTINUE
      RETURN
      END

      FUNCTION XTP(A,B,M,M0,L,X)
      PARAMETER(Pi=3.14159265358979323846)
      INTEGER J,M,M0
      REAL A,B,L,P,X,Z
      DIMENSION A(0:361),B(0:361)
      P=A(0)/2
      DO 10 J=1,M
          Z=J*Pi*X/L
          P=P+A(J)*COS(Z)+B(J)*SIN(Z)
10    CONTINUE
      IF (M.LT.M0) THEN
          Z=M0*Pi*X/L
          P=P+A(M0)*COS(Z)/2
      ENDIF
      TP=P
      RETURN
      END

      SUBROUTINE PRTPOLY(M,M0,Itype)
      INTEGER Itype,K,M,M0,U,V
      IF ((Itype.EQ.1).OR.(Itype.EQ.2)) THEN
          IF (M.EQ.0) THEN
              WRITE(9,*)'P(X) = A /2'
              WRITE(9,*)'        0'
          ELSEIF (M.EQ.1) THEN
              WRITE(9,*)'P(X) = A /2 + A COS(X) + B SIN(X)'
              WRITE(9,*)'        0      1          1'
          ELSEIF (M.EQ.2) THEN
              WRITE(9,*)'P(X) = A /2 + A COS( X ) + B SIN( X ) + A COS(
     +2X ) + B SIN( 2X )'
              WRITE(9,*)'        0      1            1            2
     +        2'
          ELSE
              WRITE(9,*)'P(X) = A /2 + A COS( X ) + B SIN( X ) +...+ A C
     +OS(',M,'X ) + B SIN(',M,'X )'
              WRITE(9,*)'        0      1            1               ',M
     +,'            ',M
          ENDIF
          IF (M.LT.M0) THEN
              WRITE(9,*)' '
              WRITE(9,*)'     + A  /2 COS(',M0,'X )'
              WRITE(9,*)'       ',M0
          ENDIF
      ENDIF
      IF (Itype.GT.2) THEN
          IF (M.EQ.0) THEN
              WRITE(9,*)'P(X) = A /2'
              WRITE(9,*)'        0'
          ELSEIF (M.EQ.1) THEN
              WRITE(9,*)'                    Pi*X          Pi*X'
              WRITE(9,*)'P(X) = A /2 + A COS(----) + B SIN(----)'
              WRITE(9,*)'        0      1      L      1      L'
          ELSEIF (M.EQ.2) THEN
              WRITE(9,*)'                    Pi*X          Pi*X
     + 2Pi*X          2Pi*X'
              WRITE(9,*)'P(X) = A /2 + A COS(----) + B SIN(----) + A COS
     +(-----) + B SIN(-----)'
              WRITE(9,*)'        0      1      L      1      L      2
     +   L       2      L'
          ELSE
              WRITE(9,*)'                    Pi*X          Pi*X
     +     ',M,'Pi*X          ',M,'Pi*X'
              WRITE(9,*)'P(X) = A /2 + A COS(----) + B SIN(----) +...+ A
     + COS(------) + B SIN(------)'
              WRITE(9,*)'        0      1      L      1      L         '
     +,M,'      L       ',M,'      L'
          ENDIF
          IF (M.LT.M0) THEN
              WRITE(9,*)' '
              WRITE(9,*)'                 ',M0,'Pi*X '
              WRITE(9,*)'     + A  /2 COS(------)'
              WRITE(9,*)'       ',M0,'           L'
          ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE INPUTFUN(FunType,FunMax)
      INTEGER FunType,FunMax,I,K
      REAL Resp
      DO 10 I=1,20
         WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'     Choose your function:'
      WRITE(9,*)' '
      FunMax=7
      DO 20 K=1,FunMax
          WRITE(9,*)' '
          CALL PRINTFUN(K)
20    CONTINUE
      WRITE(9,*)' '
      WRITE(9,*)'     SELECT < 1 - ',FunMax,' > '
      READ(9,*) Resp
      FunType=INT(Resp)
      IF ((FunType.LT.1).OR.(FunType.GT.FunMax))  FunType=1
      RETURN
      END

      SUBROUTINE GETDATA(F,X,Y,M,M0,N,N0,A0,B0,L,Ftype,Itype,
     +FunType,FunMax)
      PARAMETER(Pi=3.14159265358979323846)
      INTEGER Ftype,FunMax,FunType,Itype,K,M,M0,MAX,N,N0
      REAL A0,B0,H,L,X,Y
      DIMENSION X(0:361),Y(0:361)
      EXTERNAL F,FX
      DO 10 I=1,20
         WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'     The trigonometric polynomial of degree M is constr
     +ucted'
      WRITE(9,*)' '
      WRITE(9,*)'P(X) = A /2 + A COS(X) + B SIN(X) +...+ A COS(MX) + B S
     +IN(MX)'
      WRITE(9,*)'        0      1          1              M           M'
      WRITE(9,*)' '
      WRITE(9,*)'It is the `least squares fit` for the N data points (X
     +,Y ).'
      WRITE(9,*)'                                                      K
     +  K'
      WRITE(9,*)'The abscissas are equally spaced: X  = A + (B-A)/N for
     +K=0,..,N'
      WRITE(9,*)'                                   K'
      WRITE(9,*)'and the ordinates are periodic, i.e. Y  = Y '
      WRITE(9,*)'                                      N    0'
      WRITE(9,*)' '
      WRITE(9,*)'     Choose the interval type:'
      WRITE(9,*)' '
      WRITE(9,*)' <1> [-Pi,Pi]     <2> [0,2Pi]     <3> [0,Pi]'
      WRITE(9,*)' '
      WRITE(9,*)' <4> [-L,L]       <5> [0,L]       <6> [A,B]'
      WRITE(9,*)' '
      WRITE(9,*)'     Select  <1-6> '
      READ(9,*) Itype
      IF (Itype.EQ.1) THEN
          A0=-Pi
          B0=Pi
          L=Pi
      ELSEIF (Itype.EQ.2) THEN
          A0=0
          B0=2*Pi
          L=Pi
      ELSEIF (Itype.EQ.3) THEN
          A0=0
          B0=Pi
          L=Pi/2
      ELSEIF (Itype.EQ.4) THEN
          WRITE(9,*)' '
          WRITE(9,*)'     The interval is [-L,L], Enter  L = '
          READ(9,*) L
          A0=-L
          B0=L
      ELSEIF (Itype.EQ.5) THEN
          WRITE(9,*)' '
          WRITE(9,*)'     The interval is [0,L], Enter  L = '
          READ(9,*) L
          A0=0
          B0=L
          L=L/2
      ELSEIF (Itype.EQ.6) THEN
          WRITE(9,*)' '
          WRITE(9,*)'     The interval is [A,B].'
          WRITE(9,*)' '
          WRITE(9,*)'     Enter the left  endpoint  A = '
          READ(9,*) A0
          WRITE(9,*)' '
          WRITE(9,*)'     Enter the right endpoint  B = '
          READ(9,*) B0
          L=(B0-A0)/2
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'     There are N `periodic` data points, enter  N = '
      READ(9,*) N
      N0=N
      WRITE(9,*)'     Degree of the trigonometric polynomial is  M = '
      READ(9,*) M
      M0=M
      WRITE(9,*)' '
      MAX=INT((N-1)/2)
      IF (M.GT.MAX)  M=MAX
      IF (INT(N/2).NE.0) THEN
          M0=M
      ELSE
          IF (N.LT.(1+2*M0)) THEN
              M0=M+1
          ELSE
              M0=M
          ENDIF
      ENDIF
      H=(B0-A0)/N
      DO 20 K=0,(N-1)
         X(K)=A0+K*H
20    CONTINUE
      X(N)=B0
      DO 30 I=1,20
         WRITE(9,*)' '
30    CONTINUE
      IF (M.EQ.M0) THEN
          WRITE(9,*)'The trigonometric polynomial of degree ',M,' is con
     +structed.'
      ENDIF
      IF (M.LT.M0) THEN
          WRITE(9,*)'The trigonometric polynomial of degree ',M0,' is co
     +nstructed.'
      ENDIF
      WRITE(9,*)' '
      CALL PRTPOLY(M,M0,Itype)
      WRITE(9,*)' '
      WRITE(9,*)'Over the interval [ ',A0,' , ',B0,'  ]'
      WRITE(9,*)' '
      IF (Itype.EQ.1 .OR. Itype.EQ.2) THEN
          WRITE(9,*)'of width 2Pi.'
      ELSEIF (Itype.EQ.1 .OR. Itype.EQ.2) THEN
          WRITE(9,*)'of width Pi.'
      ELSEIF (Itype.EQ.4 .OR. Itype.EQ.5 .OR. Itype.EQ.5) THEN
          WRITE(9,*)'where L =',L
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'     Do you want to enter data points or use Y  = F(X )
     + ?'
      WRITE(9,*)'                                              K      K'
      WRITE(9,*)' '
      WRITE(9,*)'<1>  Enter data points.'
      WRITE(9,*)' '
      WRITE(9,*)'<2>  Use   Y  = F(X ).'
      WRITE(9,*)'            K      K'
      WRITE(9,*)' '
      WRITE(9,*)'     Select  <1 - 2> '
      READ(9,*) Ftype
      WRITE(9,*)' '
      IF (Ftype.EQ.2) THEN
          FunMax=7
          CALL INPUTFUN(FunType,FunMax)
          DO 40 K=0,(N-1)
              Y(K)=F(X(K),FunType)
40        CONTINUE
          Y(N)=Y(0)
      ELSE
          WRITE(9,*)' '
          WRITE(9,*)'ENTER THE ',N,' ORDINATES  Y , Y ,...,Y  . '
          WRITE(9,*)'                          0   1     ',N-1
          WRITE(9,*)' '
          DO 50 K=0,(N-1)
              WRITE(9,*)'X[',K,' ] = ',X(K),'     Y[',K,' ] = '
              READ(9,*) Y(K)
50        CONTINUE
          Y(N)=Y(0)
      ENDIF
      DO 60 I=1,20
         WRITE(9,*)' '
60    CONTINUE
      WRITE(9,*)'     Let me think for a while.'
      WRITE(9,*)' '
      WRITE(9,*)'It takes a considerable amount of computing effort to f
     +ind:'
      WRITE(9,*)' '
      CALL PRTPOLY(M,M0,Itype)
      IF (Ftype.EQ.2) THEN
          WRITE(9,*)' '
          WRITE(9,*)'For the function:'
          WRITE(9,*)' '
          WRITE(9,*)'     '
          CALL PRINTFUN(FunType)
      ENDIF
      RETURN
      END

      SUBROUTINE PRTCOEF(A,B,M,M0,Itype)
      INTEGER Itype,K,M,M0
      REAL A,B
      DIMENSION A(0:361),B(0:361)
      WRITE(9,*)' '
      IF (Itype.GT.2) THEN
          WRITE(9,*)'           L =',L
      ELSE
          WRITE(9,*)' '
      ENDIF
      DO 10 K=0,M
          WRITE(9,*)'     A(',K,') =',A(K)
10    CONTINUE
      IF (M.LT.M0)  WRITE(9,*)'     A(',M0,') =',A(M0)
      DO 20 K=1,M
          WRITE(9,*)'     B(',K,') =',B(K)
20    CONTINUE
      RETURN
      END

      SUBROUTINE RESULTS(TP,A,B,X,Y,XK,M,M0,N,N0,L,Itype,Ftype,FunType)
      INTEGER Ftype,FunType,Itype,K,M,M0,N,N0
      REAL A,B,Err,L,PK,X,XK,Y,YK
      DIMENSION A(0:361),B(0:361),X(0:361),Y(0:361)
      EXTERNAL TP
      DO 10 I=1,20
         WRITE(9,*)' '
10    CONTINUE
      IF (Ftype.EQ.2) THEN
          WRITE(9,*)'     '
          CALL PRINTFUN(FunType)
      ENDIF
      WRITE(9,*)' '
      CALL PRTPOLY(M,M0,Itype)
      CALL PRTCOEF(A,B,M,M0,Itype)
      WRITE(9,*)' '
      WRITE(9,*)'   K         X(K)            Y(K)            P(X(K))
     +         Error'
      DO 20 K=0,N
          XK=X(K)
          YK=Y(K)
          PK=TP(A,B,M,M0,L,XK)
          Err=YK-PK
          WRITE(9,1000) K,XK,YK,PK,Err
20    CONTINUE
      PAUSE
      RETURN
1000  FORMAT(I4,1X,F15.7,1X,F15.7,1X,F15.7,1X,F15.7)
      END
